#include "share.h"
#include "tlhelp32.h"
#define TH32CS_SNAPNOHEAPS 0x40000000
#pragma comment(lib,"toolhelp.lib")

class THIWinTools:public TDebug
{
   private:
   
   public:
    THI_Event *_data_Text;
    THI_Event *_data_Handle;

    HI_WORK( _work_doVisible)
    {
       DWORD f = ReadBool(_Data)?SW_SHOW:SW_HIDE;
       ShowWindow((HWND)ReadInteger(_Data,_hie(THIWinTools)->_data_Handle,0),f);
    }
    HI_WORK( _work_doPopup)
    {
       HWND h = ReadBool(_Data)?HWND_TOPMOST:HWND_NOTOPMOST;
       SetWindowPos((HWND)ReadInteger(_Data,_hie(THIWinTools)->_data_Handle,0),h,0,0,0,0,SWP_NOSIZE | SWP_NOMOVE);
    }
    HI_WORK( _work_doClose)
    {
       PostMessage((HWND)ReadInteger(_Data,_hie(THIWinTools)->_data_Handle,0), WM_QUIT, 0, 0);
    }
    HI_WORK( _work_doUpdate)
	{ 
	InvalidateRect((HWND)ReadInteger(_Data,_hie(THIWinTools)->_data_Handle,0), NULL,true);
	UpdateWindow((HWND)ReadInteger(_Data,_hie(THIWinTools)->_data_Handle,0)); 
	}
    HI_WORK( _work_doActive){ SetForegroundWindow((HWND)ReadInteger(_Data,_hie(THIWinTools)->_data_Handle,0)); }
    HI_WORK( _work_doCaption){ SetWindowText((HWND)ReadInteger(_Data,_hie(THIWinTools)->_data_Handle,0),PChar(ReadString(_Data,_hie(THIWinTools)->_data_Text,string(_his(""))))); }    
    HI_WORK( _work_doEnable)
    {
       bool en = ReadBool(_Data);
       EnableWindow((HWND)ReadInteger(_Data,_hie(THIWinTools)->_data_Handle,0), en);
    }
     HI_WORK( _work_doSendToBack)
    {
       SetWindowPos((HWND)ReadInteger(_Data,_hie(THIWinTools)->_data_Handle,0), HWND_BOTTOM,0,0,0,0,SWP_NOSIZE | SWP_NOMOVE |SWP_NOACTIVATE | SWP_NOOWNERZORDER);
    }
    HI_WORK( _work_doMinimize)
    {
      ShowWindow((HWND)ReadInteger(_Data,_hie(THIWinTools)->_data_Handle,0),SW_MINIMIZE);
    }
    HI_WORK( _work_doNormal)
    {
      ShowWindow((HWND)ReadInteger(_Data,_hie(THIWinTools)->_data_Handle,0),SW_SHOW);
    }
    HI_WORK( _work_doMaximize )
    {
      ShowWindow((HWND)ReadInteger(_Data,_hie(THIWinTools)->_data_Handle,0),SW_MAXIMIZE);
    }

    HI_WORK_LOC(THIWinTools,_var_CaptionText);
    HI_WORK_LOC(THIWinTools,_var_FileName);
};
//#############################################################################

void THIWinTools::_var_CaptionText(TData &_Data,WORD Index)
{
  HI_RSTRING buf[MAX_PATH];
  buf[ GetWindowText((HWND)ReadInteger(_Data,_data_Handle,0),buf,MAX_PATH) ] = 0;
  CreateData(_Data,string(buf));
}

void THIWinTools::_var_FileName(TData &_Data,WORD Index)
{
         HWND hw = (HWND)ReadInteger(_Data,_data_Handle,0);
          DWORD lp=0;
          GetWindowThreadProcessId(hw,&lp);
           bool lRes;       
             HANDLE lProcSnapshot=CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS,0);
                   PROCESSENTRY32 procEntry;
                  if(lProcSnapshot!=INVALID_HANDLE_VALUE)
                    {
                  memset(&procEntry,0,sizeof(PROCESSENTRY32));
               procEntry.dwSize=sizeof(PROCESSENTRY32);
                lRes=Process32First(lProcSnapshot,&procEntry);
             while(lRes)
            { if(lp==procEntry.th32ProcessID)
                 CreateData(_Data,string(procEntry.szExeFile));
         lRes=Process32Next(lProcSnapshot,&procEntry);}
                   }
            CloseToolhelp32Snapshot(lProcSnapshot);
}


